#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#include "range.h"
#include "trace.h"

#ifndef STRING_SIZE
#define STRING_SIZE (512)
#endif

typedef struct _trace_list {
    mon_t *elem;
    struct _trace_list *next;
} trace_list_t;

pthread_mutex_t trace_mutex = PTHREAD_MUTEX_INITIALIZER;
trace_list_t *global_trace_list = NULL;
int global_trace_list_num = 0;

int
mon_receipt(mon_t *xmon)
{
    int i;
    trace_list_t *n;
    trace_list_t *c, *p;
    /* LOCK */

    pthread_mutex_lock(&trace_mutex);

#if 0
fprintf(stderr, "regist %p '%s' '%s'\n", xmon, xmon->name, xmon->nic);
#endif

    p = NULL;
    c = global_trace_list;
    i = 0;
    while(c) {
        i++;
        p = c;
        c = c->next;
    }

    n = (trace_list_t*)malloc(sizeof(trace_list_t));
    if(n==NULL) {
        goto skip;
    }
    n->elem = xmon;
    n->next = NULL;
    global_trace_list_num++;

    if(p==NULL) {
        global_trace_list = n;
    }
    else {
        p->next = n;
    }
    
    xmon->reg = 1;

#if 0
    c = global_trace_list;
    i = 0;
    while(c) {
        if(c==xmon)
            fprintf(stderr, " %3d* %x %x (duplicated)\n", i, c, c->next);
        else
            fprintf(stderr, " %3d: %x %x\n", i, c, c->next);
        i++;
        c = c->next;
    }
#endif

skip:

    /* UNLOCK */
    pthread_mutex_unlock(&trace_mutex);

    return 0;
}


char *global_trace_mask="";

int
wake_traces()
{
    register char *p, *q;
    register int c;
    char tmp[STRING_SIZE];
    int i;
    trace_list_t *xc;

#if 1
    fprintf(stderr, "check trace flags (registed %d)\n",
        global_trace_list_num);
    fprintf(stderr, "trace mask \"%s\"\n", global_trace_mask);
#endif

    pthread_mutex_lock(&trace_mutex);

    p = global_trace_mask;

    while(*p) {
        c = 0;
        q = tmp;
        while(c<STRING_SIZE && *p && *p!=',') {
            c++;
            *q++ = *p++;
        }
        *q = '\0';

#if 0
    fprintf(stderr, "name '%s'\n", tmp);
#endif

        xc = global_trace_list;
        i = 0;
        while(xc) {
            if(xc->elem) {
#if 0
fprintf(stderr, " %3d: %x %x %-16s %s ",
    i, xc, xc->elem, xc->elem->name, xc->elem->nic);
#endif
                if(xc->elem->name && strcmp(tmp, xc->elem->name)==0) {
#if 0
fprintf(stderr, " *MATCH* name\n");
#endif
#if 1
fprintf(stderr, "name '%s' is registed in trace_list\n", tmp);
#endif
                    break;
                }
                if(xc->elem->nic && strcmp(tmp, xc->elem->nic)==0) {
#if 0
fprintf(stderr, " *MATCH* nic\n");
#endif
#if 1
fprintf(stderr, "nic '%s' is registed in trace_list\n", tmp);
#endif
                    break;
                }

#if 0
fprintf(stderr, " no\n");
#endif
            }
            i++;
            xc = xc->next;
        }

        if(xc && xc->elem) {
            xc->elem->sw = 1;
        }

        if(strcasecmp(tmp, "all")==0) {
            xc = global_trace_list;
            i = 0;
            while(xc) {
                if(xc->elem) {
                    xc->elem->sw = 1;
                }
                i++;
                xc = xc->next;
            }
        }

        if(*p==',') {
            p++;
            continue;
        }
        else {
            break;
        }
    }

#if 1
    xc = global_trace_list;
    i = 0;
    while(xc) {
        if(xc->elem) {
            fprintf(stderr, " %3d: %x : %x %c%c %-16s %s\n",
                i, xc,
                xc->elem,
                    xc->elem->reg ? 'R' : '-',
                    xc->elem->sw ? 'T' : '-',
                    xc->elem->name, xc->elem->nic);
        }
        i++;
        xc = xc->next;
    }
#endif

    pthread_mutex_unlock(&trace_mutex);

}


